﻿using DetourFunc.ClrType;
using System;
using System.Linq;
using System.Reflection;
using WindowsPE;

public struct Test
{
}

// Install-Package DetourFunc -Version 1.0.4
class Program
{
    static unsafe void Main(string[] _)
    {
        MyMain<bool, int> m = new MyMain<bool, int>();
        m.Main();
    }
}

class MyMain<T, T2>
{ 
    public void Main()
    {
        this.Method(5);
        this.Method2("6");
        this.Method3(new Test());
        this.Method4(false, 5);

        OutputMethodInfo(this.Method);
        Console.WriteLine();
        OutputMethodInfo(this.Method2);
        Console.WriteLine();
        OutputMethodInfo(this.Method3);
        Console.WriteLine();
        OutputMethodInfo<T, T2>(this.Method4);

        Console.ReadLine();
        //this.Method(5);
    }

    private void Method3(Test test)
    {
    }

    private void Method4<T, T2>(T _, T2 _2)
    {
    }

    private static unsafe void OutputMethodInfo<T, T2>(Action<T, T2> ivd)
    {
        OutputMethodInfo(ivd.Method);
    }

    private static unsafe void OutputMethodInfo(Action<Test> ivd)
    {
        OutputMethodInfo(ivd.Method);
    }

    private static unsafe void OutputMethodInfo(Action<int> ivd)
    {
        OutputMethodInfo(ivd.Method);
    }

    private static unsafe void OutputMethodInfo(Action<string> ivd)
    {
        OutputMethodInfo(ivd.Method);
    }

    private static unsafe void OutputMethodInfo(MethodInfo mi)
    {
        IntPtr funcPtr = mi.MethodHandle.GetFunctionPointer();

        Console.WriteLine($"TypeHandle == MethodTable: {mi.DeclaringType.TypeHandle.Value.ToInt64():x}");
        Console.WriteLine($"MethodHandle == Method Desc: {mi.MethodHandle.Value.ToInt64():x}");
        Console.WriteLine($"Method FunctionPointer: {funcPtr.ToInt64():x}");

        MethodDesc md = MethodDesc.ReadFromAddress(mi.MethodHandle.Value);
        md.Dump(Console.Out);

        // IntPtr methodAddressRef = new IntPtr(((int*)mi.MethodHandle.Value.ToPointer() + 2));
        // Console.WriteLine($"methodAddressRef: {methodAddressRef.ToInt64():x}: {methodAddressRef.ReadPtr().ToInt64():x}");



        // TypedReference tr = __makeref(pg);
        // IntPtr objectPtr = **(IntPtr**)(&tr);

        // Console.WriteLine($"Program object address in GC heap: {objectPtr.ToInt64():x}");

        // IntPtr methodTable = objectPtr.ReadPtr();
        // Console.WriteLine($"Method Table: {methodTable.ToInt64():x}");
    }

    void Method(int n)
    {
        Console.WriteLine(n);
    }

    void Method2(string txt)
    {
        Console.WriteLine(txt);
    }
}

